--addon name, addon namespace
local _, ans = ...;

local MAX_BUFFS = 5;

local function addTwoAuras(frame, aura, num, isBuff)
    local auraNamePrefix, auras, selfAnchor, prevAuraAnchor, firstAuraAnchor;
    if (isBuff) then
        auras = frame.buffFrames;
        auraNamePrefix = "Buff";
        selfAnchor = "BOTTOMRIGHT";
        prevAuraAnchor = "BOTTOMLEFT";
        firstAuraAnchor = "TOPRIGHT";
    else
        auras = frame.debuffFrames;
        auraNamePrefix = "Debuff";
        selfAnchor = "BOTTOMLEFT";
        prevAuraAnchor = "BOTTOMRIGHT";
        firstAuraAnchor = "TOPLEFT";
    end

    if num > 3 and num <= MAX_BUFFS then
        local frameName = frame:GetName();
        local frameAuraName = frameName .. auraNamePrefix .. num;
        local auraFrame = _G[frameAuraName];
        
        if (not auraFrame) then
            auraFrame = CreateFrame("Button", frameAuraName, frame, "Compact" .. auraNamePrefix .. "Template");
            auraFrame:ClearAllPoints();
            auraFrame:SetSize(auras[1]:GetSize());
            auraFrame:SetScale(auras[1]:GetScale());
            if (num == 4) then
                local frameAura1Name = frameName .. auraNamePrefix .. 1;
                auraFrame:SetPoint(selfAnchor, _G[frameAura1Name], firstAuraAnchor);
            else
                local prevFrameAuraName = frameName .. auraNamePrefix .. num - 1;
                auraFrame:SetPoint(selfAnchor, _G[prevFrameAuraName], prevAuraAnchor);
            end
        end
        
        CompactUnitFrame_UtilSetBuff(auraFrame, aura);
    end

    return num + 1;
end

local function CompactUnitFrameAuras_laod()
    -- hide CompactPartyFrames name and update scale
    CompactPartyFrame:SetScale(1.2);
    for i = 1, MEMBERS_PER_RAID_GROUP do     
        local frame = _G["CompactPartyFrameMember" .. i];
        if (frame) then
            frame.name:SetAlpha(0);
        end
        for j = 1, 3 do 
            local buffFrame = _G["CompactPartyFrameMember" .. i .. "Buff" .. j];
            local debuffFrame = _G["CompactPartyFrameMember" .. i .. "Debuff" .. j];
            buffFrame:SetScale(0.9);
            debuffFrame:SetScale(0.9);
        end
    end

    -- show 5 buffs and debuffs on CompactPartyFrames
    if (false) then
        hooksecurefunc("CompactUnitFrame_UpdateAuras", function(frame, unitAuraUpdateInfo)
            if (frame:GetName():match("^CompactPartyFrame")) then
                local frameBuffNum = 1;
                local frameDebuffNum = 1;

                frame.buffs:Iterate(function(auraInstanceID, aura)
                    frameBuffNum = addTwoAuras(frame, aura, frameBuffNum, true);
                    if (frameBuffNum > MAX_BUFFS) then
                        return true;
                    end
                    return false;
                end);
                frame.debuffs:Iterate(function(auraInstanceID, aura)
                    frameDebuffNum = addTwoAuras(frame, aura, frameDebuffNum, false);
                    if (frameDebuffNum > MAX_BUFFS) then
                        return true;
                    end
                    return false;
                end);
            end
        end);
    end
end

ans.CompactUnitFrameAuras_laod = CompactUnitFrameAuras_laod;